#include <stdio.h>
#include <string.h>
#include <errno.h>
#include "pz.h"

static PzModule *module = NULL;
static char *text = NULL;
static PzWidget *wid;
static int sh, status;
static int x, y, direct;
static ttk_color bg, ccolor;
#define SAFE_FREE( ptr ) \
	if(ptr) \
	{ \
		free(ptr); \
		ptr=NULL; \
	}

static void chrd_do_draw (PzWidget *wid, ttk_surface srf)
{

 bg = ttk_ap_get("window.bg")->color; 
 ccolor = ttk_makecol(BLACK);


	// Draw the message
	char *p;
	int y = wid->y + 5;

	for( p=text; (*p); ++p ) {
		char svch;
		if (strchr (p, '\n')) {
			svch = *strchr (p, '\n');
			*strchr (p, '\n') = 0;
		} else {
			svch = 0;
		}
		if (bg == ccolor) {
		ttk_text (srf, ttk_textfont, x, y, ttk_makecol (WHITE), p);} else {ttk_text (srf, ttk_textfont, x, y, ttk_makecol (BLACK), p);}
		p += strlen (p);
		y += ttk_text_height (ttk_textfont) + 1;
		*p = svch;
	}
}



static void movetxt()
{
	switch (sh){
	 case 1:
	     x--;
	     sh++;
	     break;
	 case 2:
	     x--;
	     sh++;
	     break;
	 case 3:
	     x--;
	     sh++;
	     break;
	 case 4:
	     x--;
	     sh++;
	     break;
	 case 5:
	     x--;
	     sh++;
	     break;
	 case 6:
	     x--;
	     sh++;
	     break;
	 case 7:
	     x--;
	     sh++;
	     break;
	 case 8:
	     x--;
	     sh = 1;
	     break;
	}
	wid->dirty++;
}


static int event_chrd (PzEvent *e)
{
   
   int ret = TTK_EV_CLICK;
   
   switch (e->type) {
    case PZ_EVENT_SCROLL: //scroll function
     TTK_SCROLLMOD( e->arg, 5);
      if( e->arg > 0){
	x--;
	x--;
	x--;

	} else {x++;
	x++;
	x++;}
       wid->dirty++;
       break;

     case PZ_EVENT_BUTTON_DOWN:
       switch (e->arg) {

      case PZ_BUTTON_MENU:
          pz_close_window(e->wid->win);
        break;

		case PZ_BUTTON_ACTION:
		sh = 1;
		status = 0;
		wid->dirty++;
		break;

      case PZ_BUTTON_PLAY:
		status = 1;
		break;
	}
	case PZ_EVENT_TIMER:
		if (status == 0) movetxt();
		break;
   }
   return ret;
}


static void cleanup_chrd()
{
}


static PzWindow *new_chrd_window()
{
     PzWindow *ret;
	FILE *fp;

    x=0;
    status=1;
	fp = fopen (pz_module_get_datapath (module, "tab.txt"), "r");
	if (!fp) {
		pz_warning ("Could not read from %s: %s.", pz_module_get_datapath (module, "tab.txt"),
				strerror (errno));
		text = (char *)strdup ("Hi! I forgot to supply a message!");
	} else {
		long len;
		fseek (fp, 0, SEEK_END);
		len = ftell (fp);
		fseek (fp, 0, SEEK_SET);
		text = malloc (len + 1);
		fread (text, 1, len, fp);
		text[len] = 0;
	}
	direct=0;
    ret = pz_new_window ("Guitar Tab Reader", PZ_WINDOW_NORMAL); 
    wid = pz_add_widget(ret, chrd_do_draw, event_chrd);
    pz_widget_set_timer(wid, 150);
    return pz_finish_window (ret);
}

static void init_chrd()
{
    module = pz_register_module ("chrd", cleanup_chrd);
    pz_menu_add_action ("/Extras/Utilities/Guitar Tab Reader", new_chrd_window);
}

PZ_MOD_INIT (init_chrd)

